

// Send known data to test line quality and protocol
#define VUC_TEST_PROTO		0


// default baudrate (if interface is serial)
//#define BAUDRATE		38400
//#define BAUDRATE		57600
#define BAUDRATE		115200
//#define BAUDRATE		230400
//#define BAUDRATE		460800


/* keep in sync w/ config.mk! */
#define F_CPU			16000000


//#define VUC_DEMO_VER		"0.0.2"


#define LED0_PORT_NAME		B
#define LED0_BIT_NO		5


#define SCOPE_TRIGGER		128		// Trigger-level 1-255
#define SCOPE_SIZE		250
#define SCOPE_FREQ		62500		// Default sample freq. Adjust ADC_PRESC_BITS, SCOPE_PRESC_VAL and SCOPE_PRESC_BITS accordingly


// Generator/PWM-Output
#define PWM_DEFAULT		1000		// Freq. on startup
#define PWM_TIMER_NO		1		// Must be 16 bit timer
#define PWM_COMP_CH		A		// Comparator channel
#define PWM_PORT_NAME		B		// Output-Port
#define PWM_BIT_NO		1		// Output-Bit-No


// Scope/ADC-Input
#define ADC_REF_BITS		(1<<REFS1)|(1<<REFS0)	// Internal 1.1V
//#define ADC_REF_BITS		(1<<REFS0)	// Avcc (1.8-6V, usually 3.3 or 5V)

// At 1 MHz ADC-Clock, we get 8.5 bits resolution and up to 76.9 ksps
//#define ADC_PRESC_BITS		(7<<ADPS0)	// Prescaler 128
//#define ADC_PRESC_BITS		(6<<ADPS0)	// Prescaler  64
//#define ADC_PRESC_BITS		(5<<ADPS0)	// Prescaler  32
#define ADC_PRESC_BITS		(4<<ADPS0)	// Prescaler  16 -> 1 MHz ADC-Clock @ 16 MHz CPU
//#define ADC_PRESC_BITS		(3<<ADPS0)	// Prescaler   8 -> 1 MHz ADC-Clock @ 8 MHz CPU
//#define ADC_PRESC_BITS		(2<<ADPS0)	// Prescaler   4
//#define ADC_PRESC_BITS		(1<<ADPS0)	// Prescaler   2

#define ADC_IN_BITS		0		// Input Select: 0..7=ADCx, 8=Temp. Sensor, 14=1.1 V, 15=0 V


#define SCOPE_TIMER_NO		0
#define SCOPE_COMP_CH		A		// Comparator channel
#define SCOPE_PORT_NAME		C		// Output-Port
#define SCOPE_BIT_NO		ADC_IN_BITS	// Output-Bit-No

#define SCOPE_PRESC_VAL	256
//#define SCOPE_PRESC_BITS	(0<<SCOPE_CS_0)	// Timer stopped
//#define SCOPE_PRESC_BITS	(1<<SCOPE_CS_0)	// Prescaler 1
//#define SCOPE_PRESC_BITS	(2<<SCOPE_CS_0)	// Prescaler 8
//#define SCOPE_PRESC_BITS	(3<<SCOPE_CS_0)	// Prescaler 64
#define SCOPE_PRESC_BITS	(4<<SCOPE_CS_0)	// Prescaler 256
//#define SCOPE_PRESC_BITS	(5<<SCOPE_CS_0)	// Prescaler 1024
//#define SCOPE_PRESC_BITS	(6<<SCOPE_CS_0)	// Clock source T0, falling edge
//#define SCOPE_PRESC_BITS	(7<<SCOPE_CS_0)	// Clock source T0, rising edge


#define VUC_PC_PUT_ADRS		1		// PC has 1 input
#define VUC_PC_GET_ADRS		0		// no outputs


#define VUC_UC_PUT_ADRS		3		// no of inputs
#define VUC_UC_GET_ADRS		1		// no of outputs


/*****************************************************\

  Stuff

\*****************************************************/

#define CONCAT__2(a, b)		a ## b
#define CONCAT(a, b)		CONCAT__2(a, b)
#define CONCAT__3(a, b, c)	a ## b ## c
#define CONCAT3(a, b, c)	CONCAT__3(a, b, c)
