
// set to 1 to have data sent in packets w/ handshake
#define VUC_PACKET		1

// set to 1 to also have a checksum for each packet
#define VUC_PKT_CHK		1

// set to 1 to also have a sequence no for each packet
#define VUC_PKT_SEQ		1


#define COM_SER			1		// Include support for RS232
#define COM_USB			1		// Include support for USB (not implemented yet)
#define COM_UDP			1		// Include support for inet
#ifdef HAVE_SYS_SOCKET_H
#  define COM_UNIX		1		// Include support for unix domain sockets
#else
#  define COM_UNIX		0
#endif


#define VUC_SCOPE_NORM		0xffff

//#define VUC_SCOPE_BEAM_COLOR	"#41ff00"	// P1 "Green"
#define VUC_SCOPE_BEAM_COLOR	"#66ffaa"	// P2 "Blue-Green"
//#define VUC_SCOPE_BEAM_COLOR	"#0066ff"	// P11 "blue"
//#define VUC_SCOPE_BEAM_COLOR	"#4cff00"	// P31 "Yellowish-green"

#define VUC_SCOPE_DIV_COLOR	"#303030"

typedef struct {
  gint count;
  GdkPoint * points;
  GdkColor div_color, beam_color;
  GtkDrawingArea * area;
  GdkRectangle rect;
#if (GTK_3)
  cairo_surface_t * csurf;
#else
  GdkPixmap * pixmap;
  GdkGC * gc;
#endif
} vuc_scope_t;

vuc_scope_t * vuc_scope_init (gint no_of_points, gchar * name);

void vuc_scope_update (vuc_scope_t * sc);


/* Send some 8-bit-values to uC */
void vuc_put_8 (guint channel, guint count, ...);

/* Send some 16-bit-values to uC */
void vuc_put_16 (guint channel, guint count, ...);


GtkBuilder * vuc_init (
  gint default_rate,
  gsize xml_len, const gchar * xml_data,
  gint put_cnt, vuc_put_data_t * put_data,
  gint get_cnt, vuc_get_data_t * get_data,
  int argc, char * argv[]
);

gint vuc_go (void);

gint vuc_exit (void);
